import dotenv from "dotenv";

// Load environment variables from .env file
dotenv.config();

export class EnvService {
  private static instance: EnvService;
  private env: any;

  private constructor() {
    // Get the parsed environment variables
    this.env = dotenv.config().parsed;
  }

  public static getInstance(): EnvService {
    if (!EnvService.instance) {
      EnvService.instance = new EnvService();
    }
    return EnvService.instance;
  }

  public getEnvVariable(name: string): string | undefined {
    return this.env[name];
  }
}
